mirror of the now-defunct rocklinux.org
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

1287 lines
38 KiB

  1. #!/bin/bash
  2. #
  3. # --- ROCK-COPYRIGHT-NOTE-BEGIN ---
  4. #
  5. # This copyright note is auto-generated by ./scripts/Create-CopyPatch.
  6. # Please add additional copyright information _after_ the line containing
  7. # the ROCK-COPYRIGHT-NOTE-END tag. Otherwise it might get removed by
  8. # the ./scripts/Create-CopyPatch script. Do not edit this copyright text!
  9. #
  10. # ROCK Linux: rock-src/scripts/Build-Pkg
  11. # ROCK Linux is Copyright (C) 1998 - 2006 Clifford Wolf
  12. #
  13. # This program is free software; you can redistribute it and/or modify
  14. # it under the terms of the GNU General Public License as published by
  15. # the Free Software Foundation; either version 2 of the License, or
  16. # (at your option) any later version. A copy of the GNU General Public
  17. # License can be found at Documentation/COPYING.
  18. #
  19. # Many people helped and are helping developing ROCK Linux. Please
  20. # have a look at http://www.rocklinux.org/ and the Documentation/TEAM
  21. # file for details.
  22. #
  23. # --- ROCK-COPYRIGHT-NOTE-END ---
  24. exec 2>&1
  25. buildstart="`date "+%m/%d/%Y from %T"`"
  26. options=''
  27. config=default
  28. clear_src=1
  29. norebuild=0
  30. nopostinst=0
  31. update=0
  32. make_tar=''
  33. prefix="usr"
  34. prefix_auto=1
  35. pkgdir=""
  36. download=0
  37. verbose=0
  38. xtrace=0
  39. debug=0
  40. chroot=0
  41. root=""
  42. id=''
  43. desktopfiles=''
  44. desktopauto=1
  45. stagelevel=9
  46. this_is_the_2nd_run=0
  47. #
  48. # ---- Functions
  49. #
  50. help_msg() {
  51. spacer=" "
  52. echo
  53. echo "Usage: ./scripts/Build-Pkg" \
  54. "[ -0 | -1 | -2 ... | -8 | -9 ] \\"
  55. echo "$spacer [ -v ] [ -xtrace ] [ -chroot ] \\"
  56. echo "$spacer [ -root { <rootdir> | auto } ] [ -update ] \\"
  57. echo "$spacer [ -cfg <config> ] [ -nopostinst ] \\"
  58. echo "$spacer [ -prefix <prefix-dir> ] [ -norebuild ] \\"
  59. echo "$spacer [ -noclearsrc ] [ -pkgdir <pkgdir> ] \\"
  60. echo "$spacer [ -id <id> ] [ -debug ] pkg-name(s)"
  61. echo
  62. echo " Build a single package. Warning: Re-building a package might overwrite or"
  63. echo " remove configuration files; with the -update option modified files are backed"
  64. echo " up and restored after the package build. In most cases the other options are"
  65. echo " only needed by ./scripts/Build-Target when building the entire distribution."
  66. echo
  67. echo " -0, -1, ..., -9 set build stage to 0, 1, ..., 9, respectively"
  68. echo " -v be verbose"
  69. echo " -xtrace print additional xtrace (debug-)output to the"
  70. echo " build log file"
  71. echo " -chroot create and use a chroot environment"
  72. echo " -root { <rootdir> | auto } the root build directory to use;"
  73. echo " defaults to automatic setting"
  74. echo " -update backup/restore modified package files"
  75. echo " -cfg <config> the build configuration to use"
  76. echo " -nopostinst do not create postinstall files"
  77. echo " -prefix <prefix-dir> the installation prefix for packages;"
  78. echo " defaults to automatic setting"
  79. echo " -norebuild don't rebuild a previously successfully built package;"
  80. echo " if the \"retry broken\" Config option is set, don't"
  81. echo " rebuild unsuccessfully built packages, too"
  82. echo " -noclearsrc don't delete the package build directory (src.*)"
  83. echo " -pkgdir <pkgdir> path to package build config (package/..),"
  84. echo " either absolute or relative to ROCK Linux"
  85. echo " sources directory"
  86. echo " -id <id> use the given build id"
  87. echo " -debug enable debug mode: setup everything and exit before"
  88. echo " the actual build"
  89. echo " -download download missing source files"
  90. echo
  91. echo "Type './scripts/Help Build-Pkg' for details."
  92. echo
  93. }
  94. #
  95. # ---- Parse options + config and make Build-Pkg sub-calls
  96. #
  97. while [ "$1" ] ; do
  98. case "$1" in
  99. -this_is_the_2nd_run) this_is_the_2nd_run=1 ;;
  100. -[0-9]) options="$options $1" ; stagelevel=${1#-} ;;
  101. -v) options="$options $1" ; verbose=1 ;;
  102. -xtrace) options="$options $1" ; xtrace=1 ;;
  103. -debug) options="$options $1" ; debug=1 ; clear_src=0 ;;
  104. -update) options="$options $1" ; update=1 ;;
  105. -chroot) options="$options $1" ; chroot=1 ;;
  106. -chr-sub) options="$options $1" ; chroot=0 ;;
  107. -cfg) options="$options $1 $2" ; config="$2" ; shift ;;
  108. -root) options="$options $1 $2" ; root="$2" ; shift ;;
  109. -prefix) options="$options $1 $2" ;
  110. prefix_auto=0 ; prefix="$2" ; shift ;;
  111. -id) options="$options $1 $2" ; id="$2" ; shift ;;
  112. -pkgdir) options="$options $1 $2" ; pkgdir="$2" ; shift ;;
  113. -noclearsrc) options="$options $1" ; clear_src=0 ;;
  114. -norebuild) options="$options $1" ; norebuild=1 ;;
  115. -nopostinst) options="$options $1" ; nopostinst=1 ;;
  116. -download) options="$options $1" ; download=1 ;;
  117. -*) help_msg ; exit 1 ;;
  118. *) break ;;
  119. esac
  120. shift
  121. done
  122. # check if arguments are left as package names
  123. if [ $# = 0 ] ; then
  124. help_msg ; exit 1
  125. fi
  126. ./scripts/Check-System || exit 1
  127. export ROCK_CHECK_SYSTEM_OK=1
  128. . ./scripts/functions
  129. . ./scripts/parse-config
  130. if [ -z "$root" -a $stagelevel -le 1 ] || \
  131. [ -z "$root" -a $chroot -eq 1 ] || \
  132. [ "$root" = auto ]; then
  133. if [ $stagelevel -gt 0 ]; then root="build/$ROCKCFG_ID"
  134. else root="build/$ROCKCFG_ID/ROCK/$toolsdir"; fi
  135. fi
  136. [ "$pkgdir" -a "${pkgdir#/}" = "$pkgdir" ] && pkgdir="$base/$pkgdir"
  137. [ "$root" -a "${root#/}" = "$root" ] && root="$base/$root"
  138. prefix=${prefix%/} ; prefix=${prefix#/} ; root=${root%/}
  139. xroot="$root" ; [ $stagelevel -gt 1 ] && root=""
  140. if [ -z "$id" ] ; then
  141. id=`get_unique`
  142. options="$options -id $id"
  143. fi
  144. ./scripts/Build-Tools -$stagelevel -cfg $config || exit 1
  145. # more than one package are passed
  146. if [ $# -gt 1 ] ; then
  147. for x ; do
  148. if ! ./scripts/Build-Pkg $options $x && \
  149. [ "$ROCKCFG_ABORT_ON_ERROR" = 1 ] ; then
  150. exit 1
  151. fi
  152. done
  153. exit 0
  154. fi
  155. # parameter 1 has $pkg=$xpkg
  156. pkg="${1%=*}"; xpkg="${1#*=}"
  157. builddir="$base/src.$xpkg.$id"
  158. # get real pkg name for mapped packages
  159. . build/$ROCKCFG_ID/ROCK/$toolsdir/lib/pkgmapper
  160. # set desktop file name
  161. desktopfiles="$( echo ${base}/package/*/${pkg} )/*.desktop"
  162. export ROCK_PKG=$pkg
  163. export ROCK_XPKG=$xpkg
  164. mkdir -p "$builddir"; chmod 700 "$builddir"
  165. if [ "$chroot" = 1 ] ; then
  166. cd "$xroot" || exit 1
  167. x_mknod() {
  168. if [ ! -e "$1" ]; then
  169. mknod "$@"
  170. fi
  171. }
  172. mkdir -p dev/loop
  173. x_mknod dev/null c 1 3
  174. x_mknod dev/zero c 1 5
  175. x_mknod dev/random c 1 8
  176. x_mknod dev/urandom c 1 9
  177. x_mknod dev/loop/0 b 7 0
  178. x_mknod dev/loop/1 b 7 1
  179. x_mknod dev/loop/2 b 7 2
  180. x_mknod dev/loop/3 b 7 3
  181. x_mknod dev/tty c 5 0
  182. x_mknod dev/ptmx c 5 2
  183. if [ ! -L dev/fd ]; then
  184. ln -s /proc/self/fd dev/fd
  185. fi
  186. if [ "$ROCKCFG_PSEUDONATIVE" = 1 -a ! -f pseudonative_handler ]
  187. then
  188. echo_header "Preparing chroot dir for pseudonative build:"
  189. echo_status "Building pseudonative_handler."
  190. cc -static -o pseudonative_handler \
  191. $base/misc/tools-source/pseudonative_handler.c
  192. if [ ! -f /proc/sys/fs/binfmt_misc/register ] ; then
  193. echo_status "Mounting /proc/sys/fs/binfmt_misc."
  194. mount -t binfmt_misc binfmt_misc /proc/sys/fs/binfmt_misc
  195. fi
  196. echo_status "Registering pseudonative_handler."
  197. sign="$( hexdump bin/bash | head -n2 | cut -f2- -d' ' | tr -d ' \n' | \
  198. cut -c 1-40 | sed -e 's,\(..\)\(..\),\\x\2\\x\1,g' )"
  199. echo ":${arch_machine}_rock_bin:M::$sign::/pseudonative_handler:" > /proc/sys/fs/binfmt_misc/register
  200. sign="$( hexdump lib/libc.so.[0-9] | head -n2 | cut -f2- -d' ' | tr -d ' \n' | \
  201. cut -c 1-40 | sed -e 's,\(..\)\(..\),\\x\2\\x\1,g' )"
  202. echo ":${arch_machine}_rock_lib:M::$sign::/pseudonative_handler:" > /proc/sys/fs/binfmt_misc/register
  203. echo_status "Creating pseudonative bindir."
  204. rm -rf ROCK/tools.cross/pseudonative.bin
  205. mkdir -p ROCK/tools.cross/pseudonative.bin
  206. cd ROCK/tools.cross
  207. while read f
  208. do
  209. b=$(basename $f)
  210. a=${b#$arch_target-}
  211. ln -sf ../$f pseudonative.bin/$b
  212. if [ "$a" != "$b" ]; then
  213. ln -sf ../$f pseudonative.bin/$a
  214. fi
  215. done < <(
  216. find crosscc lib libexec $arch_target wrapper -xtype f -perm +111 | \
  217. xargs file -L | grep ELF.*executable | cut -f1 -d:
  218. )
  219. echo_status "Applying some bin hotfixes."
  220. ln -s ../bin/true pseudonative.bin/umount
  221. ln -s ../bin/true pseudonative.bin/mount
  222. rm -f bin/uname pseudonative.bin/uname
  223. echo_status "Creating pseudonative libdir."
  224. rm -rf pseudonative.lib; mkdir -p pseudonative.lib
  225. cp /lib/ld-linux.so.* /lib/libc.so.* pseudonative.lib/
  226. cp /lib/libnss_compat.so.* pseudonative.lib/
  227. cp /lib/libnss_files.so.* pseudonative.lib/
  228. cd ../..
  229. echo_status "Creating fake rootdir-symlink."
  230. mkdir -p $( dirname ${xroot#/} )
  231. rm -f ${xroot#/}; ln -s / ${xroot#/}
  232. fi
  233. realconf=$(cd $base/config; pwd -P)
  234. realdown=$(cd $base/download; pwd -P)
  235. realbase=$(dirname $(cd $base/scripts; pwd -P))
  236. if [ ! -e ROCK/loop/scripts ]; then
  237. mkdir -p ROCK/{loop,config,download}
  238. mount --bind $realbase $PWD/ROCK/loop
  239. mount --bind $realconf $PWD/ROCK/config
  240. mount --bind $realdown $PWD/ROCK/download
  241. fi
  242. if [ ! -f proc/mounts ]; then
  243. mount -t proc proc $PWD/proc
  244. fi
  245. for x in Documentation architecture misc package scripts target; do
  246. if [ ! -e ROCK/$x ]; then ln -s "loop/$x" "ROCK/$x"; fi
  247. done
  248. if [ ! -e "ROCK/build/$ROCKCFG_ID" ]; then
  249. mkdir -p "ROCK/build"
  250. ln -snf ../.. "ROCK/build/$ROCKCFG_ID"
  251. fi
  252. # If build is a symlink to somewhere else (NFS share for clusterbuild
  253. # usually) we do _not_ want to extract our stuff there.
  254. # Network latency!
  255. ln -s loop/src.$xpkg.$id ROCK/src.$xpkg.$id
  256. cat > "$builddir/chroot.sh" <<- EOT
  257. #!/bin/bash
  258. export ROCK_THIS_IS_CHROOT=1; cd /ROCK
  259. ./scripts/Build-Pkg $options -chr-sub -root "/" "$1"
  260. EOT
  261. cat > "$builddir/debug.sh" <<- EOT
  262. #!/bin/bash
  263. export ROCK_THIS_IS_CHROOT=1
  264. if [ ! -e $PWD/ROCK/loop/scripts ]; then
  265. mount --bind $realbase $PWD/ROCK/loop
  266. mount --bind $realconf $PWD/ROCK/config
  267. mount --bind $realdown $PWD/ROCK/download
  268. ln -s loop/src.$xpkg.$id $PWD/ROCK/src.$xpkg.$id
  269. fi
  270. chroot "$xroot" /bin/bash ROCK/src.$xpkg.$id/debug_x.sh
  271. rm -f $PWD/ROCK/src.$xpkg.$id
  272. EOT
  273. chmod +x "$builddir/debug.sh"
  274. if [ "$TZ" ] ; then
  275. if [ "${TZ#/}" != "$TZ" ] ; then
  276. cp $TZ ROCK/localtime
  277. else
  278. cp /usr/share/zoneinfo/$TZ ROCK/localtime
  279. fi
  280. else
  281. if [ -f /etc/localtime ] ; then
  282. cp /etc/localtime ROCK/localtime
  283. else
  284. ln -s /usr/share/zoneinfo/Factory ROCK/localtime
  285. fi
  286. fi
  287. TZ="/ROCK/localtime" chroot . bin/bash ROCK/src.$xpkg.$id/chroot.sh
  288. returncode=$?
  289. umount $PWD/ROCK/loop
  290. umount $PWD/ROCK/config
  291. umount $PWD/ROCK/download
  292. umount $PWD/proc
  293. # Only remove $builddir if it is empty.
  294. rmdir --ignore-fail-on-non-empty "$realbase/src.$xpkg.$id"
  295. exit $returncode
  296. fi
  297. if [ "$ROCKCFG_FLIST" = "flwrapper" -a -z "$FLWRAPPER" ] ; then
  298. export FLWRAPPER_WLOG="$builddir/fl_wrapper.wlog"
  299. export FLWRAPPER_RLOG="$builddir/fl_wrapper.rlog"
  300. export FLWRAPPER_BASEPID=$$
  301. [ "$LD_PRELOAD" ] && LD_PRELOAD="${LD_PRELOAD}:"
  302. export FLWRAPPER="$base/build/$ROCKCFG_ID/ROCK/$toolsdir/lib/fl_wrapper.so"
  303. export LD_PRELOAD="${LD_PRELOAD}$FLWRAPPER"
  304. fi
  305. export INSTALL_WRAPPER_LOGFILE="$builddir/install_wrapper.log"
  306. export CMD_WRAPPER_LOGFILE="$builddir/cmd_wrapper.log"
  307. if [ $norebuild = 1 -a -f $root/var/adm/logs/$stagelevel-$xpkg.log ] ; then
  308. echo_pkg_deny $stagelevel $pkg "already built"
  309. exit 0
  310. fi
  311. if [ "$ROCKCFG_RETRY_BROKEN" = 0 -a $norebuild = 1 -a \
  312. -f $root/var/adm/logs/$stagelevel-$xpkg.err ] ; then
  313. echo_pkg_deny $stagelevel $pkg "already failed"
  314. exit 1
  315. fi
  316. confdir=""
  317. archdir="$builddir/archdir"
  318. if [ -z "$pkgdir" ] ; then
  319. for x in package/*/$pkg/$pkg.desc ; do
  320. if [ -f "$x" ] ; then
  321. if [ "$confdir" ] ; then
  322. echo_pkg_deny $stagelevel $pkg "in multiple trees"
  323. echo "Package in multiple trees: $pkg !" \
  324. > $root/var/adm/logs/$stagelevel-$xpkg.err
  325. exit 1
  326. fi
  327. x=${x#package/}; x=${x%%/*}
  328. confdir="$base/package/$x/$pkg"
  329. repository=$x
  330. fi
  331. done
  332. else
  333. if [ -f "$pkgdir/$pkg.desc" ] ; then
  334. confdir="$pkgdir"
  335. repository=extern
  336. fi
  337. fi
  338. if [ -z "$confdir" ] ; then
  339. echo_pkg_deny $stagelevel $pkg "does not exist" ; exit 1
  340. fi
  341. mkdir -p $root/var/adm/{logs,flists,cksums,md5sums,packages,dependencies}
  342. mkdir -p $root/var/adm/{dep-debug,parse-config,cache,descs,rock-debug}
  343. [ "$root" ] && chmod 700 $root
  344. rm -f $root/var/adm/logs/$stagelevel-$xpkg.{out,log,err}
  345. if [ $this_is_the_2nd_run = 0 ] ; then
  346. [ $stagelevel -gt 1 ] && . /etc/profile
  347. options="-this_is_the_2nd_run $options $pkg=$xpkg"
  348. if [ "$ROCKCFG_CREATE_CACHE" = 1 -a $stagelevel -gt 1 ] ; then
  349. mkdir -p $root/var/adm/cache
  350. touch $root/var/adm/cache/$xpkg
  351. rm -f $root/var/adm/cache/$xpkg.tm
  352. /usr/bin/time -o "$root/var/adm/cache/$xpkg.tm" \
  353. -f 'buildtime=$(qcalc %U + %S)' $0 $options
  354. returncode=$?
  355. [ ! -e "$root/var/adm/cache/$xpkg.tm" ] && exit $returncode
  356. qcalc() { gawk "BEGIN { printf(\"%d\n\", ($*)*100); }"; }
  357. eval "`grep -v '^Command ' < $root/var/adm/cache/$xpkg.tm`"
  358. rm -f $root/var/adm/cache/$xpkg.tm
  359. {
  360. errortag=""
  361. if [ -f "$root/var/adm/logs/$stagelevel-$xpkg.err" ] ; then
  362. errortag=" ERROR"
  363. fi
  364. if [ -f $confdir/$pkg.desc ] ; then
  365. grep '^\[COPY\] ' $confdir/$pkg.desc | \
  366. sed "s,/$pkg.desc\$,/$pkg.cache,"
  367. fi
  368. echo
  369. grep '^\[TIMESTAMP\]' $root/var/adm/cache/$xpkg
  370. date "+[TIMESTAMP] %s %c ($stagelevel)$errortag"
  371. echo
  372. echo "[CONFIG-ID] ${ROCKCFG_ID#*-}"
  373. echo -e "[ROCKVER] $rockver\n"
  374. echo "[LOGS]" $( cd $root/var/adm/logs ; \
  375. ls ?-$xpkg.* 2> /dev/null )
  376. echo
  377. grep '^\[BUILDTIME\]' $root/var/adm/cache/$xpkg
  378. echo "[BUILDTIME] $buildtime ($stagelevel)$errortag"
  379. x="$root/var/adm/packages/$xpkg"
  380. if [ -f $x ]; then
  381. echo "[SIZE] `grep "^Package Size: " \
  382. $x | cut -f3- -d' '`"
  383. fi
  384. echo
  385. x="$root/var/adm/dependencies/$xpkg"
  386. if [ "$pkg" != "rock-debug" -a -f $x ]; then
  387. cut -f2- -d' ' "$x" | \
  388. fmt -70 | sed 's,^,[DEP] ,'
  389. echo
  390. fi
  391. cat $root/var/adm/flists/$xpkg{,:*} 2> /dev/null | \
  392. sed -r '\,(bin/[^/]+|lib/.+\.(so|a))$, { s,.*/,,; p; };d' | \
  393. sort -u | fmt -w65 | sed 's,^,[PROVIDES] ,'
  394. echo
  395. for stagelevel in 0 1 2 3 4 5 6 7 8 9 ; do
  396. x="$root/var/adm/logs/$stagelevel-$xpkg.err"
  397. if [ -f "$x" ] ; then
  398. tail -n 50 "$x" | \
  399. sed "s,^,[$stagelevel-ERROR] ,"
  400. echo
  401. fi
  402. done
  403. } > $root/var/adm/cache/$xpkg.new
  404. mv $root/var/adm/cache/$xpkg.new $root/var/adm/cache/$xpkg
  405. exit $returncode
  406. else
  407. exec $0 $options
  408. fi
  409. fi
  410. #
  411. # ---- Setting Build Variables
  412. #
  413. flistroot="bin boot etc lib sbin usr var opt"
  414. flistrfilter="ldconfig\..*: .*|.*: /var/adm/.*"
  415. flistdel="var/adm/.*|var/tmp/.*|var/lock/.*|var/run/.*|etc/ld.so.cache|usr/tmp/.*|.*\\.old"
  416. pkgsplits=""
  417. if [ "$ROCKCFG_SPLIT_DEV" != 0 ]; then
  418. # this doesn't affect files in /lib, just /.../lib
  419. # so there needn't be an exception for linux kernel modules
  420. splitreg 40 dev '(/lib/.*\.(la|a|o)$|/include/|/man[23]/)'
  421. splitdesc_dev() { desc_I="$desc_I (development files)"; }
  422. fi
  423. if [ "$ROCKCFG_SPLIT_DOC" != 0 ]; then
  424. # only move doc/ to :doc, not man and info pages
  425. splitreg 60 doc '/share/doc/'
  426. splitdesc_doc() { desc_I="$desc_I (documentation)"; }
  427. fi
  428. if [ $stagelevel -le 1 ]
  429. then
  430. makeopt='CC="$CC" CXX="$CXX" CC_FOR_BUILD="$BUILDCC"'
  431. makeopt="$makeopt"' BUILDCC="$BUILDCC" BUILD_CC="$BUILD_CC"'
  432. makeopt="$makeopt"' HOSTCC="$HOSTCC" HOST_CC="$HOST_CC"'
  433. makeopt="$makeopt"' STRIP="$STRIP" AR="$AR" LD="$LD"'
  434. makeopt="$makeopt"' RANLIB="$RANLIB" NM="$NM"'
  435. makeinstopt="$makeopt"' prefix=$root/$prefix install'
  436. for x in prefix bindir sbindir libdir datadir \
  437. infodir mandir sysconfdir localstatedir \
  438. includedir
  439. do
  440. makeopt="$makeopt $x=\${$x/${root//\//\\/}/}"
  441. done
  442. else
  443. makeopt='prefix=/$prefix CC="$CC" CXX="$CXX"'
  444. makeinstopt='prefix=/$prefix CC="$CC" CXX="$CXX" install'
  445. flistdel="$flistdel|`echo $base | sed s,^/,,`/.*"
  446. fi
  447. prepare="" ; hook_add prepare 5 'eval "$prepare"'
  448. prepatch="" ; hook_add prepatch 5 'eval "$prepatch"'
  449. postpatch="" ; hook_add postpatch 5 'eval "$postpatch"'
  450. postdoc="" ; hook_add postdoc 5 'eval "$postdoc"'
  451. preconf="" ; hook_add preconf 5 'eval "$preconf"'
  452. premake="" ; hook_add premake 5 'eval "$premake"'
  453. inmake="" ; hook_add inmake 5 'eval "$inmake"'
  454. postmake="" ; hook_add postmake 5 'eval "$postmake"'
  455. postinstall="" ; hook_add postinstall 5 'eval "$postinstall"'
  456. postflist="" ; hook_add postflist 5 'eval "$postflist"'
  457. finish="" ; hook_add finish 5 'eval "$finish"'
  458. [ "$ROCKCFG_DO_CHECK" = 1 ] && hook_add inmake 6 'run_check'
  459. hook_add postflist 3 'postflist_libs'
  460. configprefix="" ; autogen=0 ; automakever=""
  461. configscript="./configure" ; extraconfopt=""
  462. configexec="bash"
  463. srcdir=auto ; srctar=auto
  464. taropt="--use-compress-program=bzip2 -xf"
  465. mainfunction="build_this_package"
  466. runconf=1 ; runxmkmf=1 ; runmkpl=1 ; runpysetup=1 ; autopatch=1
  467. autoextract=1 ; chownsrcdir=1 ; nocvsinsrcdir=1; patchopt="-bfp1 -z .orig"
  468. createprefix=1 ; createdocs="" ; rmemptydir="" ; autoso2a=0 ; forcefpic=""
  469. check_shared=1
  470. check_usrlocal=1
  471. check_badfiles=1
  472. badfiles="" badfiles_nr=0
  473. declare -a badfiles_desc
  474. #
  475. # ---- Read various config files
  476. #
  477. parse_desc $confdir/$pkg.desc
  478. ver="`echo "$desc_V" | tail -n 1 | cut -f1 -d' '`"
  479. extraver="`echo "$desc_V" | tail -n 1 | cut -s -f2- -d' '`"
  480. [ -z "$extraver" ] && extraver="0"
  481. if [ "$pkg" = "$xpkg" ]; then
  482. echo_pkg_start $stagelevel $repository $xpkg $ver $extraver
  483. else
  484. echo_pkg_start $stagelevel $repository $pkg=$xpkg $ver $extraver
  485. fi
  486. if [ "$ROCKCFG_PARANOIA_CHECK" = 1 -a -z "$pkgdir" ] ; then
  487. x="`./scripts/Check-PkgFormat $pkg`"
  488. [ "$x" ] && abort "$x\nDisable the 'Paranoia Check' config `
  489. `option to ignore such errors."
  490. fi
  491. targetdir="$base/target/$target"
  492. patchfiles="`ls $confdir/*.patch $confdir/*.patch.$arch \
  493. $confdir/*.patch_$xpkg $confdir/*.patch_$xpkg.$arch \
  494. $targetdir/pkg_$pkg.patch $targetdir/pkg_$pkg.patch.$arch \
  495. $targetdir/xpkg_$xpkg.patch $targetdir/xpkg_$xpkg.patch.$arch \
  496. 2>/dev/null | tr '\n' ' '`"
  497. if [ $stagelevel -le 1 ]; then
  498. patchfiles="`ls $patchfiles $confdir/*.patch.cross \
  499. $confdir/*.patch.cross.$arch 2>/dev/null | tr '\n' ' '`"
  500. fi
  501. if [ $stagelevel -eq 0 ]; then
  502. flistroot="$flistroot include share doc info man"
  503. flistroot="$flistroot crosscc wrapper $arch_target"
  504. createdocs=0
  505. fi
  506. if [ -f $confdir/$pkg.cache ]; then
  507. if ! egrep -q '^\[PROVIDES].*\.(so|a)( |$)' $confdir/$pkg.cache; then
  508. forcefpic="0"
  509. fi
  510. fi
  511. if [ $stagelevel -gt 1 ]; then
  512. for pc_file in $xroot/var/adm/parse-config/* ; do
  513. if [ -s "$pc_file" -a "${pc_file##*/}" != "$xpkg" ]
  514. then . "$pc_file" ; fi
  515. done
  516. unset pc_file
  517. fi
  518. . $base/build/$ROCKCFG_ID/ROCK/$toolsdir/lib/parse-config
  519. set_confopt
  520. if [ $stagelevel -eq 0 -a "$ROCKCFG_PSEUDONATIVE" = 1 ]; then
  521. echo_status "Building this package statically for pseudo native build."
  522. var_insert extraconfopt " " "--enable-static --disable-shared"
  523. for x in BUILDCC_WRAPPER_INSERT LDFLAGS LD CFLAGS CC; do
  524. var_append $x " " "-static"
  525. done
  526. fi
  527. eval "$desc_O"
  528. # include package pre config - if any
  529. if [ -f $base/build/$ROCKCFG_ID/ROCK/$toolsdir/lib/pkg_${pkg}_pre.conf ] ; then
  530. echo_status "Reading build/.../$toolsdir/lib/pkg_${pkg}_pre.conf"
  531. . $base/build/$ROCKCFG_ID/ROCK/$toolsdir/lib/pkg_${pkg}_pre.conf
  532. fi
  533. if [ -f $targetdir/pkg_$pkg.conf ] ; then
  534. echo_status "Reading package configuration from target directory."
  535. . $targetdir/pkg_$pkg.conf
  536. elif [ -f $confdir/$pkg.conf ] ; then
  537. echo_status "Reading package configuration from package directory."
  538. . $confdir/$pkg.conf
  539. fi
  540. # include package post config - if any
  541. if [ -f $base/build/$ROCKCFG_ID/ROCK/$toolsdir/lib/pkg_${pkg}_post.conf ] ; then
  542. echo_status "Reading build/.../$toolsdir/lib/pkg_${pkg}_post.conf"
  543. . $base/build/$ROCKCFG_ID/ROCK/$toolsdir/lib/pkg_${pkg}_post.conf
  544. fi
  545. if [ -f $base/architecture/$arch/pkg-header ] ; then
  546. echo_status "Reading overwrites from architecture/$arch/pkg-header."
  547. . $base/architecture/$arch/pkg-header
  548. fi
  549. if [ -f $base/target/$target/pkg-header ] ; then
  550. echo_status "Reading overwrites from target/$target/pkg-header."
  551. . $base/target/$target/pkg-header
  552. fi
  553. #
  554. # ---- Variable updates based on the configuration files read
  555. #
  556. if [ -z "$prefix" -o "${prefix#usr}" != "$prefix" ] ; then
  557. flistdel="$flistdel|usr/share/info/(dir|standards.info)"
  558. if [ "$ROCKCFG_DISABLE_NLS" = 1 ] ; then
  559. flistdel="$flistdel|usr/share/locale/..[/_].*"
  560. flistdel="$flistdel|usr/share/man/..[/_].*"
  561. fi
  562. if [ $stagelevel = 0 ] ; then
  563. flistdel="${flistdel//usr\//}|${flistdel//usr\/share\//}"
  564. fi
  565. else
  566. flistdel="$flistdel|$prefix/info/(dir|standards.info)"
  567. if [ "$ROCKCFG_DISABLE_NLS" = 1 ] ; then
  568. flistdel="$flistdel|$prefix/share/locale/..[/_].*"
  569. flistdel="$flistdel|$prefix/man/..[/_].*"
  570. fi
  571. fi
  572. #
  573. # ---- Build Package
  574. #
  575. echo_status "Preparing build in src.$xpkg.$id"
  576. if [ "$ROCKCFG_SRC_TMPFS" = 1 ]; then
  577. echo_status "Mounting tmpfs on src.$xpkg.$id"
  578. mount -t tmpfs -o $ROCKCFG_SRC_TMPFS_OPT tmpfs "$builddir"
  579. fi
  580. if [ "$xroot" != "$root" ] ; then
  581. for x in $flistroot ; do
  582. [ -d $xroot/$x ] || mkdir -p $xroot/$x
  583. [ -d $root/$x ] || ln -sf $xroot/$x $root/
  584. done
  585. fi
  586. if [ $update = 1 ] ; then
  587. echo_status "Creating backup of old package data (running in update mode)."
  588. (
  589. cd $xroot/
  590. grep -v "^X" var/adm/md5sums/$xpkg var/adm/md5sums/$xpkg:* 2> /dev/null |
  591. md5sum --check - 2>&1 | grep ': FAILED$' | cut -f1 -d:
  592. ) > "$builddir/backup_files.txt"
  593. if [ -s "$builddir/backup_files.txt" ] ; then
  594. mkdir -p "$xroot/var/adm/backup"
  595. chmod 700 "$xroot/var/adm/backup"
  596. backup_tar="$xroot/var/adm/backup/$(
  597. date '+%Y%m%d%H%M%S')_$xpkg.tar.bz2"
  598. ( cd $xroot/; tar --no-recursion --force-local -cf - -T "$builddir/`
  599. `backup_files.txt" || true; ) | bzip2 > $backup_tar
  600. else
  601. update=0
  602. fi
  603. fi
  604. if [ "$ROCKCFG_FLIST" = "flwrapper" ] ; then
  605. rm -f "$builddir/"fl_wrapper.{r,w}log
  606. touch "$builddir/"fl_wrapper.{r,w}log
  607. elif [ "$ROCKCFG_FLIST" = "find" ] ; then
  608. touch "$builddir/temp.time_stamp"
  609. sleep 2
  610. fi
  611. if [ $stagelevel -gt 1 -a "$autoso2a" = 1 ]; then
  612. export AUTOSO2A_DIR="$builddir/autoso2a"
  613. export AUTOSO2A_AR="$AR" AUTOSO2A_RANLIB="$RANLIB"
  614. var_insert CC_WRAPPER_OTHERS ":" "so2a_wrapper"
  615. var_insert CXX_WRAPPER_OTHERS ":" "so2a_wrapper"
  616. fi
  617. i=0
  618. mkdir -p "$builddir/wrappers"
  619. for x in "${wrapper_data[@]}"; do
  620. echo "$x" | (
  621. read n; o="$n"
  622. if [ -f "$builddir/wrappers/$n" ]; then
  623. mv "$builddir/wrappers/$n" "$builddir/wrappers/$n.$i"
  624. o="$n.$i"; (( i++ ))
  625. fi
  626. {
  627. echo '#!/bin/bash'
  628. echo 'echo "$PWD: $0 $*" >> "'"$builddir/wrappers.log"'"'
  629. echo 'PATH="$PATH_WRBACKUP"'
  630. echo "orig='$o'"
  631. cat
  632. } > "$builddir/wrappers/$n"
  633. chmod +x "$builddir/wrappers/$n"
  634. )
  635. done
  636. export PATH_WRBACKUP="$PATH"
  637. PATH="$builddir/wrappers:$PATH"
  638. unset i
  639. # make sure we don't create an flist with just an
  640. # empty docdir in it if the package build fails..
  641. flistdel="$flistdel|${docdir#$root/}"
  642. # define new abort function for errors while building
  643. #
  644. abort() {
  645. [ "$*" ] && echo "$*"; echo "--- BUILD ERROR ---"
  646. rm -vf $root/var/adm/logs/$stagelevel-$xpkg.log
  647. false
  648. }
  649. {
  650. (
  651. set -e
  652. if [ $xtrace -eq 1 -o $ROCKCFG_XTRACE -eq 1 ] ; then
  653. PS4=$'=[$FUNCNAME:$LINENO (last \\\$?=$?)> '
  654. set -o xtrace
  655. fi
  656. hook_eval prepare
  657. mkdir -p "$builddir/archdir"
  658. # Download archives files and link to them in $archdir.
  659. while read l_cksum l_srctar l_url l_flags ; do
  660. [ -z "$l_cksum" ] && continue
  661. x=`source_file l_cksum $l_srctar l_url $l_flags`
  662. if [ ! -f $x ]; then
  663. if [ $download = 1 ] ; then
  664. echo_status "Running ./scripts/Download for this package..."
  665. echo_status "----- DOWNLOAD LOG -----"
  666. echo; ./scripts/Download $xpkg; echo
  667. echo_status "------------------------"
  668. download=0
  669. fi
  670. if [ ! -f $x ]; then
  671. echo "File not found: ${x#$base/}"
  672. abort "Did you run ./scripts/Download for this package?"
  673. fi
  674. fi
  675. ln -vs $x "$builddir/archdir/"
  676. done < <( echo "$desc_D" | column_clean )
  677. trap 'echo "Got SIGINT (Crtl-C). Aborting build." ; exit 1' INT
  678. exec < /dev/null
  679. # Makes debugging build problems easier
  680. #
  681. hook_dump > "$builddir/debug.hooks"
  682. #
  683. {
  684. dump_env
  685. cat <<- EOT
  686. PS1='\\[\\e[00m\\e[01;31m\\]debug-`
  687. `$xpkg\\[\\e[00m\\]:[\\W]\\\$ '
  688. alias cp="cp -i" ; alias mv="mv -i"
  689. alias rm="rm -i" ; alias ls="ls --color=auto -a"
  690. alias ..="cd .." ; alias ...="cd ../.."
  691. alias xdiff="sh $base/misc/archive/xdiff.sh"
  692. alias bked="sh $base/misc/archive/bked.sh"
  693. fixfile () {
  694. # we use .vanilla to not rediff backup .orig from patch
  695. [ -f \$1.vanilla ] || cp \$1 \$1.vanilla
  696. \$EDITOR \$1
  697. }
  698. fixfilediff() {
  699. find -name '*.vanilla' | while read x ; do
  700. diff -u \$x \${x/.vanilla/}
  701. done
  702. }
  703. EOT
  704. } > "$builddir/debug.buildenv"
  705. #
  706. cat > "$builddir/debug_x.sh" <<- EOT
  707. #!/bin/bash
  708. export PROMPT_COMMAND='. debug.buildenv; cd .; unset PROMPT_COMMAND'
  709. cd "$builddir"; exec bash 200>> build.pid
  710. EOT
  711. #
  712. if [ "$ROCK_THIS_IS_CHROOT" != 1 ]; then
  713. mv "$builddir/debug_x.sh" "$builddir/debug.sh"
  714. chmod +x "$builddir/debug.sh"
  715. fi
  716. # Create PID file
  717. #
  718. # The builtin-variable '$$' is not this pid because this proc
  719. # is just a sub-proc of $$. That's why the $builddir/strace.tmp
  720. # hack is required to get the right pid to trace.
  721. #
  722. # We also conntect filedescriptor 3 with the pid file. So the command
  723. # 'fuser' can be used to create a list of all processes which are part
  724. # of this build process.
  725. #
  726. sh -c 'echo $PPID' > "$builddir/build.pid"
  727. exec 200>> "$builddir/build.pid"
  728. echo "Command Wrapper Debug: running '${CC} --version' .."
  729. type ${CC%% *}; CMD_WRAPPER_DEBUG=1 ${CC} --version
  730. echo "[ writing debug log to $builddir/cmd_wrapper.log ]"
  731. if [ "$debug" = 1 ] ; then
  732. echo "Everything is set up." \
  733. "We are in debug mode - so exit now."
  734. exit
  735. fi
  736. if [ "$ROCKCFG_FLIST" = "strace" ] ; then
  737. if [ "$(uname -m)" = "ppc" ]; then
  738. SYSEXIT="exit"
  739. else
  740. SYSEXIT="_exit"
  741. fi
  742. strace -o "$builddir/strace.out" -F -f -q -e open,creat,mkdir,`
  743. `mknod,link,symlink,rename,utime,chdir,execve,`
  744. `fork,clone,vfork,`
  745. `$SYSEXIT,exit_group -p `cat "$builddir/build.pid"` &
  746. strace_pid=$! ; sleep 1 ; cd $base
  747. fi
  748. echo "Running main build function '$mainfunction' ..."
  749. cd "$builddir" ; eval "$mainfunction"
  750. hook_eval postinstall
  751. echo "Creating file list and doing final adaptions ... "
  752. #
  753. cd $xroot/
  754. #
  755. if [ "$ROCKCFG_FLIST" = "strace" ] ; then
  756. sleep 1 ; kill -INT $strace_pid ; sleep 1
  757. fl_stparse -w "$builddir/fl_wrapper.wlog" \
  758. -r "$builddir/fl_wrapper.rlog" < "$builddir/strace.out"
  759. fi
  760. if [ "$ROCKCFG_FLIST" = "flwrapper" -o \
  761. "$ROCKCFG_FLIST" = "strace" ] ; then
  762. if [ "$stagelevel" -le 1 ]
  763. then
  764. xbase="$( cd $xroot/ 2> /dev/null ; pwd -P )"
  765. if egrep -qv "[ ]($base|$xbase|$builddir|/tmp|/usr/tmp|/var/tmp|/var/backups|/proc|/dev)(/|$)" \
  766. $builddir/fl_wrapper.wlog
  767. then
  768. x="Created file outside basedir: "
  769. egrep -v "[ ]($base|$xbase|$builddir|/tmp|/usr/tmp|/var/tmp|/proc|/dev)(/|$)" \
  770. $builddir/fl_wrapper.wlog | \
  771. cut -f2- | sort -u | sed "s,^,$x,"
  772. echo "base #1: $base"
  773. echo "base #2: $xbase"
  774. abort
  775. fi
  776. fi
  777. if fl_wrparse -D -s -r "$xroot/" < $builddir/fl_wrapper.wlog | \
  778. egrep "^(${flistroot// /|})(/|$)" >> \
  779. $builddir/flist.txt
  780. then : ; fi
  781. elif [ "$ROCKCFG_FLIST" = "find" ] ; then
  782. if find $flistroot \
  783. \( -not -type d -or -type d -empty \) \
  784. -and \( -newer $builddir/temp.time_stamp -or \
  785. -cnewer $builddir/temp.time_stamp \) -printf "%p\n" >> \
  786. $builddir/flist.txt
  787. then : ; fi
  788. fi
  789. # evaluate flistdel (1/2)
  790. egrep -v "^($flistdel)\$" $builddir/flist.txt | sort -u > $builddir/flist.txt.new
  791. mv $builddir/flist.txt.new $builddir/flist.txt
  792. # copy over missing *.a files
  793. if [ "$autoso2a" = 1 ]; then
  794. echo "Checking for missing .a files ..."
  795. while read d s; do
  796. grep -q "/${s%.so}.a$" $builddir/flist.txt && continue
  797. [ "$d" = "lib" ] && d="usr/lib"
  798. if [ -f "$AUTOSO2A_DIR/${s%.so}.a" ]; then
  799. echo "Installing automatically created $d/${s%.so}.a."
  800. cp "$AUTOSO2A_DIR/${s%.so}.a" "$root/$d/${s%.so}.a"
  801. add_flist "$root/$d/${s%.so}.a"
  802. else
  803. echo "Not found: $AUTOSO2A_DIR/${s%.so}.a"
  804. fi
  805. done < <( egrep '(^|/)lib/[^/]*\.so$' "$builddir/flist.txt" | sed 's,\(.*\)/,\1 ,' )
  806. fi
  807. # merge flist of previous build
  808. for x in var/adm/flists/$xpkg var/adm/flists/$xpkg:*; do
  809. [ -f $x ] && cut -f2- -d' ' $x >> "$builddir/flist.txt"
  810. done
  811. # evaluate flistdel (2/2)
  812. egrep -v "^($flistdel)\$" "$builddir/flist.txt" | sort -u > "$builddir/flist.txt.new"
  813. mv "$builddir/flist.txt.new" "$builddir/flist.txt"
  814. hook_eval postflist
  815. fl_wrparse -D -p "$xpkg" -r "$xroot/" < "$builddir/flist.txt" | sort -u > "$builddir/flist.split"
  816. echo Found `wc -l < "$builddir/flist.split"` "files for this package."
  817. splitapply $xpkg "$builddir/flist.split"
  818. if [ "$ROCKCFG_FLIST" = "flwrapper" -o \
  819. "$ROCKCFG_FLIST" = "strace" ] && [ $stagelevel -gt 1 ] ; then
  820. echo "Calculating package dependencies ..."
  821. ! egrep -v "^($flistrfilter)\$" "$builddir"/fl_wrapper.[rw]log |
  822. sort -u | fl_wrparse -D -s -r "$xroot/" -p '' | \
  823. grep -v ' var/adm/' | awk '
  824. ARGIND < ARGC-1 {
  825. if ( index($1, "'$xpkg':") != 1 )
  826. f[$2] = $1 " " f[$2];
  827. }
  828. ARGIND == ARGC-1 {
  829. file = $2;
  830. while ( file != "" ) {
  831. if ( f[file] ) {
  832. split(f[file], a);
  833. for (i in a)
  834. if (! d[a[i] " " file]) {
  835. d[a[i] " " file] = 1;
  836. print a[i] " " file;
  837. }
  838. }
  839. sub("/?[^/]*$", "", file)
  840. }
  841. }
  842. ' var/adm/flists/* - > "$builddir/dependencies.debug"
  843. awk 'BEGIN { FS=": "; } { print "'$xpkg': " $1; }' \
  844. < "$builddir/dependencies.debug" > "$builddir/dependencies.txt"
  845. if [ -f var/adm/dep-debug/$xpkg ] ; then
  846. cat var/adm/dep-debug/$xpkg >> "$builddir/dependencies.debug"
  847. fi
  848. sort -u "$builddir/dependencies.debug" > var/adm/dep-debug/$xpkg
  849. # add debug info for known false dependencies
  850. if egrep -q "^[^#].* $xpkg( |$)" $base/scripts/dep_fixes.txt; then
  851. echo "--- $xpkg [$stagelevel] ---" >> $root/var/adm/rock-debug/falsedeps.txt
  852. fi
  853. while read x; do
  854. grep "^$x: " "$builddir/dependencies.debug" | sort -u | \
  855. sed "s,:, -> $xpkg [$stagelevel]:," >> $root/var/adm/rock-debug/falsedeps.txt
  856. done < <( egrep "^$xpkg +del +" $base/scripts/dep_fixes.txt | \
  857. tr ' ' '\t' | tr -s '\t' | cut -f3- | tr '\t' '\n' )
  858. # merge the dependencies defined by the package
  859. for x in `echo "$desc_E" | egrep '^add ' | sed 's/^add //' ` ; do
  860. echo "Adding dependency: $x ..."
  861. echo "$xpkg: $x" >> "$builddir/dependencies.txt"
  862. done
  863. # remove dependencies as requested by the package
  864. # TODO: groups are not used yet (and it is not easy here)
  865. del_pattern=""
  866. for x in `echo "$desc_E" | egrep '^del ' | sed 's/^del //' ` ; do
  867. del_pattern="$del_pattern -e \".*: $x(:.*|)\$\""
  868. done
  869. if [ -n "$del_pattern" ] ; then
  870. echo "Deleting dependencies, pattern: $del_pattern ..."
  871. eval "egrep -v $del_pattern \"$builddir/dependencies.txt\"" > "$builddir/dependencies.txt.new"
  872. mv "$builddir/dependencies.txt.new" "$builddir/dependencies.txt"
  873. fi
  874. if [ -f var/adm/dependencies/$xpkg ] ; then
  875. cat var/adm/dependencies/$xpkg >> "$builddir/dependencies.txt"
  876. fi
  877. sort -u "$builddir/dependencies.txt" > "$builddir/dependencies.txt.new"
  878. mv "$builddir/dependencies.txt.new" "$builddir/dependencies.txt"
  879. fi
  880. for spkg in $( sed 's,: .*,,' < "$builddir/flist.split" | sort -u )
  881. do
  882. (
  883. if [ -z "${spkg##*:*}" ]; then
  884. splitdesc_${spkg#*:}
  885. fi
  886. echo "<$spkg> Creating flist file ..."
  887. {
  888. grep "^$spkg: " "$builddir/flist.split"
  889. [ -s "var/adm/parse-config/$spkg" ] && \
  890. echo "$spkg: var/adm/parse-config/$spkg"
  891. for x in var/adm/flists/$spkg var/adm/md5sums/$spkg \
  892. var/adm/cksums/$spkg var/adm/packages/$spkg \
  893. var/adm/descs/$spkg var/adm/dependencies/$spkg ; do
  894. touch $x ; echo "$spkg: $x"
  895. done
  896. } | sort -u > var/adm/flists/$spkg
  897. if [ -f "$builddir/dependencies.txt" ] ; then
  898. echo "<$spkg> Creating package dependencies file ..."
  899. sed "s,^[^ ]*,$spkg:," < "$builddir/dependencies.txt" > var/adm/dependencies/$spkg
  900. fi
  901. echo "<$spkg> Creating package description ..."
  902. #
  903. rocksrcck=$(cd $base; md5sum package/*/$pkg/* 2> /dev/null | \
  904. grep -v '\.cache$' | md5sum | cut -f1 -d' ')
  905. buildlist="$( grep "^Build \[.\] at " var/adm/packages/$spkg || true
  906. echo "Build [$stagelevel] at $buildstart to `date "+%T %Z"`")"
  907. #
  908. cat > var/adm/packages/$spkg << EOT
  909. Package Name and Version: $spkg $ver $extraver
  910. Package Size: `getdu $root/ < var/adm/flists/$spkg`, `
  911. wc -l < var/adm/flists/$spkg | tr -d ' '` files
  912. ROCK Linux Package Source Checksum: $rocksrcck
  913. ROCK Linux Version and Architecture: $rockver $arch
  914. Build on `uname -m -n -r -s -p`
  915. $buildlist
  916. Status: ${desc_S:-ALPHA}, License: ${desc_L:-Unknown}
  917. ${desc_I:-$spkg}
  918. $( echo "${desc_T:-No description available.}" | sed 's,^, ,' )
  919. URL(s):
  920. $( echo "${desc_U:-http://www.rocklinux.net/packages/$pkg.html}" | sed 's,^, ,' )
  921. Original Author(s):
  922. $( echo "${desc_A:-Unknown}" | sed 's,^, ,' )
  923. ROCK Package Maintainer(s):
  924. $( echo "${desc_M:-Unknown}" | sed 's,^, ,' )
  925. Download URL(s):
  926. $( echo "${desc_D:-None}" | awk '{ print " " $3 $2; }' )
  927. EOT
  928. {
  929. echo "[CONFIG] ${ROCKCFG_ID#*-}"
  930. while read x; do
  931. if [ "${x#\[}" != "$x" ]; then # "]}"
  932. x="`echo ${x// /|} | tr -d '[]'`"
  933. y="${x%%|*}" ; x="(${x%|(*)})"
  934. case "$y" in
  935. V) echo "[V] $ver $extraver" ;;
  936. *) echo "$descfile" | egrep "^\[$x\]" | expand | sed "s,^[^ ]*,[$y]," ;;
  937. esac
  938. fi
  939. done < $base/Documentation/Developers/PKG-DESC-FORMAT
  940. } > var/adm/descs/$spkg
  941. # Create them last so checksums of other var/adm files are correct.
  942. echo "<$spkg> Creating md5sum and cksum files ..."
  943. echo -n > var/adm/cksums/$spkg
  944. echo -n > var/adm/md5sums/$spkg
  945. # getfiles only returns non-directories, suitable for checksum creation.
  946. getfiles < var/adm/flists/$spkg > "$builddir/files.lst"
  947. if [ -s "$builddir/files.lst" ] ; then
  948. while read file ; do
  949. [ -z "${file//[ ]/}" ] && continue
  950. # Checksums on these files are volatile.
  951. if [ "$file" = "var/adm/cksums/$spkg" -o \
  952. "$file" = "var/adm/md5sums/$spkg" -o \
  953. -b "$file" -o -c "$file" -o -p "$file" -o \
  954. -L "$file" -o -S "$file" ] ; then
  955. echo "X ${file}" >> var/adm/md5sums/$spkg
  956. echo "X $( stat -c %s ${file} ) ${file}" \
  957. >> var/adm/cksums/$spkg
  958. elif [ ${ROCKCFG_CREATE_CKSUM} -eq 1 ] ; then
  959. md5sum "${file}" >> var/adm/md5sums/$spkg
  960. cksum "${file}" >> var/adm/cksums/$spkg
  961. else
  962. echo "0 ${file}" >> var/adm/md5sums/$spkg
  963. echo "0 $( stat -c %s ${file} ) ${file}" \
  964. >> var/adm/cksums/$spkg
  965. fi
  966. done < "$builddir/files.lst"
  967. fi
  968. if [ $stagelevel -ge 2 -a $nopostinst = 0 -a -d /var/adm/postinstall ]; then
  969. cp var/adm/flists/$spkg "$(mktemp var/adm/postinstall/${spkg}-install.XXXXXX)"
  970. fi
  971. )
  972. done
  973. echo "Making post-install adaptions."
  974. if [ $stagelevel -ge 2 -a -f /sbin/ldconfig ] ; then ldconfig ; fi
  975. if [ "$ROCKCFG_PARANOIA_CHECK" = 1 ] ; then
  976. found_errors=0
  977. found_dups=0
  978. # check for files which are 'shared' with other packages
  979. if [ "$check_shared" != "0" ]; then
  980. while read dummy file; do
  981. if [ $found_dups = 0 ] ; then
  982. echo "Found shared files with other packages:"
  983. found_errors=1; found_dups=1
  984. fi
  985. echo "$file:" $( cd $root/var/adm/flists
  986. grep -l " $file\$" * )
  987. done < <( cat $root/var/adm/flists/* | sed "s,^$xpkg:[^ ]*,.," | \
  988. sort -k2 | uniq -d -f1 | grep '^\. ' )
  989. fi
  990. found_local=0
  991. # check for files in /usr/local
  992. if [ "$check_usrlocal" != "0" ]; then
  993. while read file ; do
  994. if [ $found_local = 0 ] ; then
  995. echo "Found files in /usr/local:"
  996. found_errors=1; found_local=1
  997. fi
  998. echo $file
  999. done < <( sed "s,^$xpkg: ,/," $root/var/adm/flists/$xpkg \
  1000. $root/var/adm/flists/$xpkg:* 2> /dev/null | egrep "^/usr/local" )
  1001. fi
  1002. found_bad=0
  1003. # check for registered 'bad files'
  1004. if [ "$check_badfiles" != "0" -a -n "$badfiles" ]; then
  1005. echo "$badfiles" > "$builddir/badfiles.txt"
  1006. while read x file; do
  1007. if [ $found_bad = 0 ]; then
  1008. echo "Found registered 'bad files' in package:"
  1009. found_errors=1; found_bad=1
  1010. fi
  1011. desc="No description found!"
  1012. for ((x=0; x<badfiles_nr; x++)); do
  1013. if echo " $file" | grep -q "${badfiles_desc[x]%%$'\n'*}"
  1014. then desc="${badfiles_desc[x]#*$'\n'}"; fi
  1015. done
  1016. echo "$file: $desc"
  1017. done < <( grep -f "$builddir/badfiles.txt" $root/var/adm/flists/$xpkg \
  1018. $root/var/adm/flists/$xpkg:* 2> /dev/null )
  1019. fi
  1020. [ $found_errors != 0 ] && abort
  1021. fi
  1022. touch $root/var/adm/logs/$stagelevel-$xpkg.log
  1023. echo "Finished building $pkg=$xpkg."
  1024. hook_eval finish
  1025. )
  1026. if [ ! -f $root/var/adm/logs/$stagelevel-$xpkg.log ] ; then
  1027. abort
  1028. fi
  1029. } 2>&1 | {
  1030. trap '' INT
  1031. echo_status "Building. Writing output to" \
  1032. "\$root/var/adm/logs/$stagelevel-$xpkg.out"
  1033. if [ "$ROCKCFG_VERBOSE" = 1 -o "$verbose" = 1 ] ; then
  1034. tee $root/var/adm/logs/$stagelevel-$xpkg.out
  1035. else
  1036. cat > $root/var/adm/logs/$stagelevel-$xpkg.out
  1037. fi
  1038. }
  1039. if [ $update = 1 ] ; then
  1040. echo_status "Restoring backup of old package data."
  1041. while read fn ; do
  1042. [ -f $xroot/$fn ] && mv $xroot/$fn $xroot/$fn.new
  1043. done < "$builddir/backup_files.txt"
  1044. tar --force-local --use-compress-program=bzip2 -C $xroot/ -xpf $backup_tar
  1045. while read fn ; do
  1046. cmp -s $fn $fn.new && rm -f $fn.new
  1047. done < "$builddir/backup_files.txt"
  1048. fi
  1049. cd $base
  1050. umount -r -d -f "$builddir"/* 2> /dev/null
  1051. umount -r -d -f -l "$builddir"/* 2> /dev/null
  1052. if [ "$ROCKCFG_SRC_TMPFS_LOG" = 1 -a -n "$( type -p df )" ]; then
  1053. if [ ! -f $root/var/adm/rock-debug/tmpfslog.txt ] ; then
  1054. echo -e "# Config\tPackage\tInodes\tKB" | \
  1055. expand -t20 > $root/var/adm/rock-debug/tmpfslog.txt
  1056. fi
  1057. echo -e "$config\t$stagelevel-$xpkg\t$(
  1058. df 2> /dev/null -Pi "$builddir" | tail -n 1 | tr -s ' ' | cut -f3 -d' '
  1059. )\t$(
  1060. df 2> /dev/null -Pk "$builddir" | tail -n 1 | tr -s ' ' | cut -f3 -d' ')" | \
  1061. expand -t20 >> $root/var/adm/rock-debug/tmpfslog.txt
  1062. fi
  1063. if [ "$ROCKCFG_PSEUDONATIVE" = 1 -a $stagelevel -eq 0 ]; then
  1064. rm -f $base/build/$ROCKCFG_ID/pseudonative_handler
  1065. fi
  1066. if [ "$ROCKCFG_FLIST" = "flwrapper" ] ; then
  1067. export LD_PRELOAD="${LD_PRELOAD//${FLWRAPPER}/}"
  1068. export LD_PRELOAD="${LD_PRELOAD//::/:}"
  1069. fi
  1070. if [ "$ROCKCFG_SRC_TMPFS" = 1 ]; then
  1071. umount -l "$builddir"
  1072. fi
  1073. if [ -f $root/var/adm/logs/$stagelevel-$xpkg.log ] ; then
  1074. if [ $clear_src = 1 ] ; then
  1075. rm -rf "$builddir"/* "$builddir"
  1076. else
  1077. cp $root/var/adm/logs/$stagelevel-$xpkg.out "$builddir/BUILD-LOG"
  1078. fi
  1079. echo_status "\$root/var/adm/logs/$stagelevel-$xpkg.out" \
  1080. "-> $stagelevel-$xpkg.log"
  1081. mv $root/var/adm/logs/$stagelevel-$xpkg.out \
  1082. $root/var/adm/logs/$stagelevel-$xpkg.log
  1083. echo_pkg_finish $stagelevel $repository $xpkg
  1084. exit 0
  1085. else
  1086. if [ $clear_src = 1 -a "$ROCKCFG_ALWAYS_CLEAN" = 1 ] ; then
  1087. rm -rf "$builddir"/* "$builddir"
  1088. else
  1089. cp $root/var/adm/logs/$stagelevel-$xpkg.out "$builddir/ERROR-LOG"
  1090. fi
  1091. if [ "$ROCKCFG_VERBOSE" != 1 -a "$verbose" != 1 ] ; then
  1092. echo_errorquote "$( grep -B7 -- '--- BUILD ERROR ---' \
  1093. $root/var/adm/logs/$stagelevel-$xpkg.out | \
  1094. sed '$ s,--- BUILD ERROR ---,,' | \
  1095. grep . | grep -vx -- -- )"
  1096. fi
  1097. echo_status "\$root/var/adm/logs/$stagelevel-$xpkg.out" \
  1098. "-> $stagelevel-$xpkg.err"
  1099. mv $root/var/adm/logs/$stagelevel-$xpkg.out \
  1100. $root/var/adm/logs/$stagelevel-$xpkg.err
  1101. echo_pkg_abort $stagelevel $repository $xpkg
  1102. exit 1
  1103. fi
  1104. # ---- EOF